#!/usr/bin/perl

$VERSION="2.1";

# Changes :

#v2.1  05 Oct. 1998
#       La recherche de champ "Sender" s'effectue sur une equivalence "$1
#       eq $2" et non plus sur une aproximation "if (/blabla/)".
#       Cela evite de ce tromper qaund Sender=subscribe-frmug et que vous
#       recherchez uniquement "frmug"...

#v2.0  02 Mai  1998

#      Verifie tous les champs connus dans \@liste_entete
#      A pour effet : reconnaitre plusieur mailing-list,
#		      et decodage de plusieur facon d'ecrire
#		      dans les header de mails. Ok ? :)

# v1.8 09 Avr. 1998

#	Reconnaissance du champ To: et Recent-Sender pour mailing-list
#	autre que majordomo.

# v1.6 23 Oct. 1997

#	Ajoute le champ "Cc: mailing-list@..."


# v1.5 20 Oct. 1997


$DEBUG		= 00;
$NEWSMASTER	= "postmaster";
$SENDER		= "news\@gyptis.frmug.org"; # Signature de l'envoyeur!
$group_num	= 1;
$sortie		= SOUT;
$RNEWS		= "/usr/bin/rnews";
$MAIL		= "/usr/bin/rmail";
$SENDMAIL	= "/usr/sbin/sendmail ";
#$SENDMAIL	= "/usr/sbin/sendmail";
$config_file	= "/usr/local/lib/mail2news.cfg";
$SIGNATURE	= "mail2news";
@list_entete	= { "Sender: ", "Reply-To: ", "Recent-Sender: ", "CC: ", "Cc: ", "cc: ", "To: "};


&setup;

if ($0 =~ "m2n.pl")
{
   $TMP_FILE	= "/tmp/m2n.$$";
   &mail2news;
}
else
{
   $TMP_FILE	= "/tmp/n2m.$$";
   &news2mail;
}

sub mail2news
{
    if (&mailtonews == 1)
    {
       close $sortie;
       $buf = sprintf "%s  postmaster ", $MAIL;

       # On bricole :)
       open(LINE, "$TMP_FILE");
       open(OUT, "|$MAIL mans");
       printf OUT "From news\@gyptis.frmug.org\n";
       while(<LINE>)
       {
           printf OUT "%s", $_;
       }
       close(OUT);
       close(LINE);

       #$buf = sprintf "%s < %s", $buf, $TMP_FILE;
       #system $buf;
       &del_exit;
    }
    close $sortie;
   
    $buf = sprintf "%s %s", $RNEWS, $TMP_FILE;
    system $buf;
    &del_exit;
}
    
sub news2mail
{

    #if (!$ARGV[0])
    #{
    #      open (OUT, "|$SENDMAIL"." $NEWSMASTER");
    #      printf OUT "X-m2n: Pas d'arguments\n";
    #      &vide_ta_queue;
    #      close OUT;
    #      exit (1);
    #}
    #if ( !($numba = &check_mailing("$ARGV[0]") ))
    #{
    #   open (OUT, "|$SENDMAIL"." $NEWSMASTER");
    #   printf OUT "X-m2n: %s n'esxiste pas!\n", $ARGV[0];
    #   &vide_ta_queue;
    #   close (OUT);
    #   exit (1);
    #}

    #open (OUT, "|$SENDMAIL"." $to[$numba]");
    open (OUT, ">" . "$TMP_FILE")|| die "ca marche pas";

    while(<STDIN>)
    {
      if (!$header)
      {
       if (/^\n/)
       {
          printf OUT "Recent-Sender: %s", $SENDER;
          $header =1;
          printf OUT "\n";
       }
       elsif (/(Newsgroups\: )(.*)/ && !$header)
       {
          $newsgroup = $2;
       }
      }
       printf OUT "%s", $_;
    }
    close(OUT);

    if (!$newsgroup)
    {
       $buf = sprintf "%s -s no_var_newsgroup %s \< %s", $MAIL, $NEWMASTER, $TMP_FILE;
       system $buf;
       &del_exit;
    }
    $newgroup =~ s/\t/ /g;
    while ($newsgroup =~ s/  / /g) {}

    $new_num = split (/\,/, $newsgroup, 9999);
    @new     = split (/\,/, $newsgroup, 9999);

    $new_num--;
    for ($o = $new_num; $o >= 0 ; $o --)
    {
       if ( !($numba = &check_mailing("$new[$o]") ))
       {
          #&send_newmaster("$TMP_FILE", "Newsgroup non existant dans mail2news.cfg");
          #del_exit (1);
       }
       else
       {
          &send_mail("$to[$numba]");
          $valid_group = 1;
       }
    }   # For
    if (!$valid_group)
    {
       &send_newmaster("$TMP_FILE");
    }
    &del_exit;
}

sub send_mail
{
    local($var) = @_;
    
    open (LINE, "$TMP_FILE");
    open (OUT,  "|$SENDMAIL " . " $var");

    while(<LINE>)
    {
       if (/^From:/)
       {
          printf OUT $_;
          printf OUT "To: %s\n", $var;
          printf OUT "Cc: %s\n", $var;
          while (<LINE>) { printf OUT $_; }
       }
       printf OUT $_;
    }

    #$buf = sprintf "%s %s \< %s", $SENDMAIL, $var, $TMP_FILE;
    #printf "%s\n", $buf;
    #system $buf;

    close OUT;
    close LINE;

    return;
}

sub send_newmaster
{
    local($var) = @_;

    $buf = sprintf "%s %s \< %s", $SENDMAIL, $NEWSMASTER, $TMP_FILE;
 printf "sendnew: %s\n", $buf;
    #system $buf;
    &del_exit (1);
}

sub vide_ta_queue  # :)
{
          while(<STDIN>)
          {
             printf $sortie "%s", $_;
          }
          close($sortie);
}

sub check_mailing
{
    local($var) = @_;
    local ($i);

    if (!$var)  { return 0; # pas d'arguments 
    }
    for($i = $group[0]; $i >= 0; $i--)
    {
       if ($group[$i] =~/^$var\b/)
       {
          if ($DEBUG >= 20) {
          printf "Trouve: %s\n", $group[$i];
          }
          return $i; # Ca existe!
       }
    }
}

sub del_exit
{
    $buf = sprintf "rm -f %s", $TMP_FILE;
    system $buf;
    exit;
}

sub setup
{
    open (LINE, "$config_file");

    while (<LINE>)
    {
       if (/^(GROUP*\t)(.*)/)  #if (/^(GROUP*)\s*.* (.*)\s*.* (.*)\s*.* (.*)$/)
       {
          #s/\t/ /g;
          $_ = $2;
          while (s/\t\t/\t/g) {}
          while (s/  / /g) {}
          @arg = split (/\t/, $_, 9999);
          $arg_num = split (/\t/, $_, 9999);
          if ($arg_num != 3)
          {
             die "ATTENTION: il y a plus de 3 arguments dans la chaine GROUP, impossible de continuer, veuillez adapte la chiane group a 3 arguments.";
          }
          $group_num++;
          $mailing[$group_num] = $arg[0];
          $group[$group_num] = $arg[1];
          $to[$group_num] = $arg[2];
          if ($DEBUG >= 20)
          {
             printf "Read-mail2news.cfg: mailing: %s, group: %s, to: %s\n", $mailing[$group_num], $group[$group_num], $to[$group_num];
          }
       }
       elsif (/^(PATH*\t)(.*)/)
       {
          $PATH = $2;
       }
       $mailing[0]	= $group_num;
       $group[0]	= $group_num;
       $to[0]		= $group_num;
    }
}

sub mailtonews
{
    open ($sortie, ">" . "$TMP_FILE");

    printf $sortie "Path: %s\n", $SIGNATURE;
    printf $sortie "X-m2n.pl: **************************************************\n";
    printf $sortie "X-m2n.pl: * VERSION $VERSION 2 Mai 1998 (mans\@gyptis.frmug.org) *\n";
    printf $sortie "X-m2n.pl: * convert mail2news, news2mail, only file/config *\n";
    printf $sortie "X-m2n.pl: **************************************************\n";

    while (<STDIN>)
    {
      if (/^\n/ && !$header)
      {
         printf $sortie "\n";
         &vide_ta_queue;

         $header = 1; # OFF
         if ($sender)
         {
            return;
         }
         else
         {
            return 1;
         }
      } # IF 1

      $nia = $_;

      if (/^Path:/)
      {
         if (/gyptis/)
         {
            &vide_ta_queue;
            &del_exit; # On l'a deja dans les news!
         }
      }
      elsif ( ( /^(Reply-To: )(.*)/ || /^(Sender: )(.*)/ || /(^Cc: )(.*)/ || /^(Recent-Sender: )(.*)/ || /^(cc: )(.*)/ || /^(To: )(.*)/  ) && !$sender )
      #elsif ( &on_cherch($_) && !$sender )
      {
         printf $sortie "%s", $_;
         $ret = 0;

         #printf $sortie "X-m2n.pl: On_Bosse\n";

         if ( ($ret = &on_bosse($_)) )
         {
            if ( !($ret == 1) )
            {
               printf $sortie "X2-m2n.pl: ret: %s\n", $ret;
               return $ret;
            }
         }
      }
      elsif (/^Newsgroups: (.*)/)
      {
         $newsgroup = $2;
         printf $sortie "%s", $_;
         &vide_ta_queue;
         $header = 2; # OFF
         return 2;
      }
      elsif (!/^From /)
      {
         printf $sortie "%s", $_;
      }
    } # While 1

   close $sortie;
   if (!$sender)
   {
      return 1;
   }
} # end sub mailtonews

sub on_cherch
{
    local($nia)  = @_;
    local($i);

    foreach $i (@list_entete)
    {
printf "XX: %s:%s\n", $nia, $i;
       if ( ( $nia =~ /^$i/)  && !$sender )
       {
          if($DEBUG >= 20) { printf $sortie "X-m2n.pl: TROUVE!!: %s", $_; }
          return 1;
       }
    }
}

sub on_bosse
{
    local($_) = @_;

         if($DEBUG >= 20) { printf $sortie "X-m2n.pl: %s", $_; }
         $from = $2;

         if ($from =~ /\<(.*)\>/)
         {
            $from = $1;
         }

         if ($from =~ /(.*)(\@)(.*)/)
         {
             $from = $1;
         }

         if ($DEBUG >= 20)
         {
            printf $sortie "X-m2n.pl: Mailing-Argument-number: %s\n", $mailing[0];
         }
         undef $GROUP;

         if ($DEBUG)
         {
            printf $sortie "X-m2n.pl: Search-group: %s\n", $from;
         }

         for ($i = 1; $i <= $mailing[0]; $i++)
         {
            if ("$from" eq "$mailing[$i]")
            {
               $GROUP = $group[$i];
               if ($DEBUG)
               {
                  printf $sortie "X-m2n.pl: GROUP: trouve: \"%s\"\n", $GROUP;
               }
            }
         if ($DEBUG >= 20)
         {
            printf $sortie "X-m2n.pl: Search-group: From %s, mailing %s\n", $from, $mailing[$i];
         }
         }

         if ( !$GROUP )
         {
            printf $sortie "X-m2n.pl-message: Je trouve pas group: $GROUP\n";
            #while(<STDIN>)
            #{
            #    printf $sortie "%s", $_;
            #}
            return(1);
         }
         printf $sortie "Newsgroups: %s\n", $GROUP;
         $sender = 1;
}


# Cette fonction sert a eviter qu'un mail, envoyer par la mailing-list 
# vers le serveur de news, soit renvoyer a ses expediteurs.
#
# Toute fois elle ne sert a rien dans la mesur ou votre serveur de news
# peut faire ce genre de filtrage. Parceque tout bon serveur qui se
# respectent doit savoir annalyser le champ "Path:" ou la fonctionn
# mail2news additionne sa SIGNATURE (mail2news) au reste de ce champ
# Et par consequent doit savoir qu'il est passe, grace a ce champ, par lui.
#
# Avec INND ceci ce fait dans le fichier NEWSFEEDS comme suit :
#
#  mail-list/mail2news:!*,plug:Tp:/usr/rmail mailing-list
# 
#              ^ la SIGNTURE!
sub news2mail_OLD
{
    open (OUT, "/tmp/n2m."."$TMP_FILE");
    while (<STDIN>)
    {
        if (/(^Path:)(.*)/)
        {
           @nia = split (/\!/, $2, 9999);
           $nio = split (/\!/, $2, 9999);
           for (; $nio >= 0; $nio--)
           {
              if ($nia[$nio] =~ /$SIGNATURE/)
              {
                 return;
              }
           }
           printf "1: %s\n", $2;
        }
    }
}
